Module SSD1306

'   ,    
'  7  |
'  6  |
'  5  |
'  4  |
'  3  |
'  2  |
'  1  |
'  0  ------------------------> 127
'

Include "I2C.bas"
Include "String.bas"
Include "Font7x5.bas"

Dim 
   I2CWriteByte As WriteByte,
   I2CInitialize As Initialize,
   I2CStart As Start,
   I2CStop As Stop

Const SSD1306_I2C_Address As Byte = $78
Const SSD1306_LCDWIDTH				= 128 
Const SSD1306_LCDHEIGHT     		= 64 
Const SSD1306_SETCONTRAST   		= $81 
Const SSD1306_DISPLAYALLON_RESUME	= $A4 
Const SSD1306_DISPLAYALLON			= $A5
Const SSD1306_NORMALDISPLAY			= $A6
Const SSD1306_INVERTDISPLAY			= $A7
Const SSD1306_DISPLAYOFF			= $AE
Const SSD1306_DISPLAYON				= $AF
Const SSD1306_SETDISPLAYOFFSET		= $D3
Const SSD1306_SETCOMPINS			= $DA
Const SSD1306_SETVCOMDETECT			= $DB
Const SSD1306_SETDISPLAYCLOCKDIV	= $D5
Const SSD1306_SETPRECHARGE			= $D9
Const SSD1306_SETMULTIPLEX			= $A8
Const SSD1306_SETLOWCOLUMN			= $00
Const SSD1306_SETHIGHCOLUMN			= $10
Const SSD1306_SETSTARTLINE			= $40
Const SSD1306_MEMORYMODE			= $20
Const SSD1306_COLUMNADDR			= $21
Const SSD1306_PAGEADDR				= $22
Const SSD1306_COMSCANINC			= $C0
Const SSD1306_COMSCANDEC			= $C8
Const SSD1306_SEGREMAP				= $A0
Const SSD1306_CHARGEPUMP			= $8D
Const SSD1306_EXTERNALVCC			= $1
Const SSD1306_SWITCHCAPVCC			= $2

Dim CursorX, CursorY As Byte
Dim CurWidth, CurHeight As Byte
Dim CurInv As Bit

'  
Public Sub Contrast(y As Byte)
	I2CStart
	I2CWriteByte( SSD1306_I2C_Address)
	I2CWriteByte( $0)					' This is Command 
    I2CWriteByte( SSD1306_SETCONTRAST)	'  
    I2CWriteByte( y)					' 0-255
    I2CStop
End Sub

'    
' X - 0-127; Y - 0-7
Public Sub SetCursor(x As Byte, y As Byte)
    CursorY = y							'    
    CursorX = x							' 
	I2CStart
	I2CWriteByte( SSD1306_I2C_Address)
	I2CWriteByte( $0)					' This is Command 
    I2CWriteByte( $B0 Or Y)				'  
    I2CWriteByte( X And $0F)			'  
    I2CWriteByte((X >> 4) Or $10)
	I2CStop
End Sub

' ----------------------------------------------------------------------------
'  
' cod -   
' tip -       (   )
' inv - 0- 1-,  
' shi -  0/1- 7-.
' vis -  0/1-, 7-
Public Sub PrintByte(ByVal cod As Byte, tip As Bit = 0, inv As Bit = 0, shi As Byte = 1, vis As Byte = 1)
	Dim a, b, bufr, mask, vm, z As Byte
	Dim codw As Word
	Dim risun1, risun2, bufr1, bufr2 As LongWord

	'     
    If shi = 0 Then	shi = 1	EndIf	'  1  0 -> 1
    shi = shi And $07				'    7
    If vis = 0 Then vis = 1 EndIf	'  1  0 -> 1
    vis = vis And $07				'    7
	CurWidth = shi
	CurHeight = vis
	CurInv = inv

    codw = ( cod - $20) * 5			'      
	'  
	I2CStart
	I2CWriteByte( SSD1306_I2C_Address)
	I2CWriteByte( $0)			' This is Command 
	I2CWriteByte( $20)			'   Y  
	I2CWriteByte( $1)
	I2CStop

	For b = 0 To 4
		'    
        bufr = SHRIFT( codw + b)
        If inv = 1 Then bufr = Not bufr	EndIf

		'   
        mask = $80
        risun1 = 0
        risun2 = 0
		'  bufr   
		For z = 0 To 7
			For vm = 0 To vis - 1
				risun2 = risun2 << 1    
				If (risun1 And $80000000) > 0 Then risun2 = risun2 Or 1 EndIf    
				risun1 = risun1 << 1
				If (bufr And mask) > 0 Then risun1 = risun1 Or 1 EndIf
           Next
            mask = mask >> 1	'   
		Next

		'   
		For a = 0 To shi - 1
			'    E
            bufr1 = risun1
            bufr2 = risun2
			'  
			SetCursor( CursorX, CursorY)
			CursorX = CursorX + 1

			I2CStart
			I2CWriteByte( SSD1306_I2C_Address)
			I2CWriteByte( $40)			' This is Data
			I2CWriteByte(bufr1)
			If vis > 1 Then
				bufr1 = bufr1 >> 8
            	I2CWriteByte( bufr1)
            	If vis > 2 Then
					bufr1 = bufr1 >> 8
					I2CWriteByte( bufr1)
					If vis > 3 Then
						I2CWriteByte( bufr1 >> 8)
						If vis > 4 Then
							I2CWriteByte( bufr2)
							If vis > 5 Then
								bufr2 = bufr2 >> 8
								I2CWriteByte( bufr2)
								If vis > 6 Then
									bufr2 = bufr2 >> 8
									I2CWriteByte( bufr2)
									If vis > 7 Then
										I2CWriteByte( bufr2 >> 8)
									EndIf
								EndIf
							EndIf
						EndIf
					Endif
				EndIf
			EndIf
            I2CStop
		Next
	Next
	' ------------------------------------------------------------------------------
	'    0-/1-
	'  
    If tip = 0 Then
        SetCursor( CursorX, CursorY)
        CursorX = CursorX + 1

		I2CStart
	    I2CWriteByte( SSD1306_I2C_Address)
	    I2CWriteByte( $40)			' This is Data
		For a = 0 To vis - 1
			If inv = 0 Then
				I2CWriteByte( $0)
			Else
				I2CWriteByte( $FF)
			EndIf
		Next
		I2CStop
	EndIf
	I2CStart
    I2CWriteByte( SSD1306_I2C_Address)
    I2CWriteByte( $0)			' This is Command
	I2CWriteByte( $20)			'   X  
	I2CWriteByte( $00)
	I2CStop
End Sub

'   c   
' 1-[  X][>127 =    0-127]
' 2-[  Y][ Y 0-7]
' 3-[]        
' 4-[ ] 0-  7
' 5-[ ] 0-, 1- 
' 6-[]  0 , 1 
Public Sub Print( x As Byte, y As Byte, str As String, width As Byte = 255, height As Byte = 255, inv As Byte = 255)
    Dim i, j As Byte

	If width > 7 Then width = CurWidth EndIf
	If height > 7 Then height = CurHeight EndIf
	If inv > 1 Then inv = CurInv EndIf

	j = Length(str)
	If width = 0 Then width = 1 EndIf
	If x > 127 Then	'   x < 0
		x = ( 127 - ((( j * 5) * width) + j)) / 2
	EndIf
	CursorX = x
	CursorY = y
	For i = 0 To j - 1
		PrintByte( str(i), 0, inv, width, height)
	Next
End Sub

'     
' []         
' [ ] 0-  7
' [ ] 0-, 1- 
' []  0 , 1 
Public Sub Print( str As String, width As Byte = 255, height As Byte = 255, inv As Byte = 255)	' c, , , 
    Dim i As Byte
	
	If width > 7 Then width = CurWidth EndIf
	If height > 7 Then height = CurHeight EndIf
	If inv > 1 Then inv = CurInv EndIf

	For i = 0 To Length(str) - 1
		PrintByte( str(i), 0, inv, width, height)
	Next
End Sub

'   
'	0 - 
'	1 - 
'	2 - 
Public Sub Cls(typ As Byte = 0)
	Dim j As Word

	'      0,0 
	I2CStart
	I2CWriteByte(SSD1306_I2C_Address)
	I2CWriteByte( $0)	'  

	I2CWriteByte( SSD1306_COLUMNADDR)			'  $21 
	I2CWriteByte( $0)							'    
	I2CWriteByte( SSD1306_LCDWIDTH - 1)			'    
	I2CWriteByte( SSD1306_PAGEADDR)				'  $22
	I2CWriteByte( $0)							'   
	I2CWriteByte(( SSD1306_LCDHEIGHT / 8 ) - 1)	'    
	I2CStop

    '  
	I2CStart
	I2CWriteByte( SSD1306_I2C_Address)
	I2CWriteByte( $40)	'  
	Select typ
		Case 1
			For j = 0 To 1023
				I2CWriteByte( $FF)
		    Next
		Case 2
			For j = 0 To 1023
				If j.0 = 0 Then
					I2CWriteByte( $55)
				Else
					I2CWriteByte( $AA)
				EndIf
		    Next
		Case 3
			For j = 0 To 1023
				If j.0 = 0 Then
					I2CWriteByte( $88)
				Else
					I2CWriteByte( $22)
				EndIf
		    Next
		Else
			For j = 0 To 1023
				I2CWriteByte( $0)
		    Next
	EndSelect
	I2CStop
End Sub

Public Sub Initialize()
	CurWidth = 1
	CurHeight = 1
	CurInv = 0
	CursorX = 0
	CursorY = 0

	I2CInitialize ( I2C_1000_KHZ, I2C_SLEW_OFF)

    I2CStart

	I2CWriteByte ( SSD1306_I2C_Address)
	
	I2CWriteByte ( $0)							' .   
    I2CWriteByte ( $0)							'    
    
    I2CWriteByte ( SSD1306_DISPLAYOFF)			'  

    I2CWriteByte ( SSD1306_SETDISPLAYCLOCKDIV)	'    
    I2CWriteByte ( $80)
	'                |+-----  0-F/ 0 -   1
	'                +------  .   0x80

    I2CWriteByte ( SSD1306_SETMULTIPLEX)		'  multiplex ratio
    I2CWriteByte ( $3F)							'*--1/64 duty (  )

    I2CWriteByte ( SSD1306_SETDISPLAYOFFSET)	'   (offset)
    I2CWriteByte ( $00)							'  

    I2CWriteByte ( SSD1306_SETSTARTLINE)		'     0x40   RAM

    I2CWriteByte ( SSD1306_CHARGEPUMP)			'   
    I2CWriteByte ( $14)							' $10 -  (VCC  ) $14 -   DC/DC

    I2CWriteByte ( $A1)							'     ( X)
                            					' $A1 -   (/), $A0 -  (/)

    I2CWriteByte ( SSD1306_COMSCANINC)			'    
                            					'      
                            					'  SSD1306_COMSCANINC - / (   )
                            					'  SSD1306_COMSCANDEC - / (   )

    I2CWriteByte ( SSD1306_SETCOMPINS)			'   COM
    I2CWriteByte ( $12)			'

    I2CWriteByte ( SSD1306_SETCONTRAST)			'  
    I2CWriteByte ( 150)			' 0-255

    I2CWriteByte ( SSD1306_SETPRECHARGE)		'   DC/DC 
    I2CWriteByte ( $22)							' $22-VCC   / 0xF1  

    I2CWriteByte ( SSD1306_SETVCOMDETECT)		'  VcomH
    I2CWriteByte ( $30)							'     0x30 (0x00-0x70)
    
    I2CWriteByte ( SSD1306_DISPLAYALLON_RESUME)	'  
    
    I2CWriteByte ( SSD1306_NORMALDISPLAY)		'  

    I2CWriteByte ( SSD1306_MEMORYMODE)			'   
    I2CWriteByte ( $0)				' 0 -        ()
    								' 1 -       
    								' 2 -      

    I2CWriteByte ( SSD1306_DISPLAYON)			' Display On
    I2CStop()
//------------------------------
    Cls ()							'  
End Sub
